<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE WorkFlowDefinition SYSTEM "wfdef4.dtd">
<WorkFlowDefinition ApiVersion="4.0"
Origin="JavaAPI"
	Subject="&quot;&quot;"
	Description=""
	Name="ICNParallelDocumentApproval"
	DisableEmailNotification="false"
	MainAttachment="&quot;DocumentforReview&quot;"
	Tag="&quot;ICNParallel&quot; + ICN_TeamspaceId"
	AuthorTool="Process Designer"
	OtherAuthorTools=""
	versionAgnostic="false"
	validateUsingSchema="true"
	validateFlag="true"
	transferFlag="true">
	<Field
		Name="Approvers"
		Description=""
		ValueExpr="{&quot;&quot;}"
		Type="participant"
		IsArray="true"
		MergeType="AppendNoDup"/>
	<Field
		Name="RequiredApprovalCount"
		Description=""
		ValueExpr="0"
		Type="int"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="DeadlineInMins"
		ValueExpr="0"
		Type="int"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="NoDeadline"
		ValueExpr="stringtotime(&quot;9999/12/31 00:00:00&quot;, &quot;yyyy/mm/dd hh:tt:ss&quot;)"
		Type="time"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="FinalReview"
		ValueExpr="true"
		Type="boolean"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="DocumentforReview"
		ValueExpr="&quot;||0|0||&quot;"
		Type="attachment"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="RequiredApprovalPercentage"
		ValueExpr="100"
		Type="float"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="ICN_AllowReassign"
		ValueExpr="false"
		Type="boolean"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="ICN_Instructions"
		ValueExpr="&quot;&quot;"
		Type="string"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="ApprovalPercentage"
		ValueExpr="0.0"
		Type="float"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="ICN_WFDeadlineDate"
		ValueExpr="stringtotime(&quot;9999/12/31 00:00:00&quot;, &quot;yyyy/mm/dd hh:tt:ss&quot;)"
		Type="time"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="ApproverCount"
		ValueExpr="0"
		Type="int"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="Errors"
		ValueExpr="{&quot;&quot;}"
		Type="string"
		IsArray="true"
		MergeType="override"/>
	<Field
		Name="References"
		ValueExpr="{&quot;||0|0||&quot;}"
		Type="attachment"
		IsArray="true"
		MergeType="AppendNoDup"/>
	<Field
		Name="ICN_TeamspaceId"
		ValueExpr="&quot;&quot;"
		Type="string"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="StartTime"
		ValueExpr="systemtime()"
		Type="time"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="EndDateMinuteOffset"
		ValueExpr="0"
		Type="int"
		IsArray="false"
		MergeType="override"/>
	<Field
		Name="EndDateSecondOffset"
		ValueExpr="0"
		Type="int"
		IsArray="false"
		MergeType="override"/>
	<Map
		Name="Workflow"
		MaxStepId="34" >
		<Step
			StepId="0"
			Name="Launch"
			XCoordinate="336"
			YCoordinate="136"
			RequestedInterface="Navigator Launch Pattern Processor"
			JoinType="none"
			SplitType="or"
			CanReassign="true"
			CanViewStatus="true"
			CanViewHistory="false"
			IgnoreInvalidUsers="false">
			<Parameter
				Name="Approvers"
				Description=""
				ValueExpr="Approvers"
				Type="participant"
				IsArray="true"
				Mode="inout"/>
			<Parameter
				Name="FinalReview"
				ValueExpr="FinalReview"
				Type="boolean"
				IsArray="false"
				Mode="inout"/>
			<Parameter
				Name="RequiredApprovalCount"
				Description=""
				ValueExpr="RequiredApprovalCount"
				Type="int"
				IsArray="false"
				Mode="inout"/>
			<Parameter
				Name="RequiredApprovalPercentage"
				ValueExpr="RequiredApprovalPercentage"
				Type="float"
				IsArray="false"
				Mode="inout"/>
			<Parameter
				Name="ICN_AllowReassign"
				ValueExpr="ICN_AllowReassign"
				Type="boolean"
				IsArray="false"
				Mode="inout"/>
			<Parameter
				Name="ICN_Instructions"
				ValueExpr="ICN_Instructions"
				Type="string"
				IsArray="false"
				Mode="inout"/>
			<Parameter
				Name="DocumentforReview"
				Description=""
				ValueExpr="DocumentforReview"
				Type="attachment"
				IsArray="false"
				Mode="inout"/>
			<Parameter
				Name="ICN_TeamspaceId"
				ValueExpr="ICN_TeamspaceId"
				Type="string"
				IsArray="false"
				Mode="inout"/>
			<Parameter
				Name="References"
				Description=""
				ValueExpr="References"
				Type="attachment"
				IsArray="true"
				Mode="inout"/>
			<Parameter
				Name="ICN_WFDeadlineDate"
				ValueExpr="ICN_WFDeadlineDate"
				Type="time"
				IsArray="false"
				Mode="inout"/>
			<Route
				SourceStepId="0"
				DestinationStepId="34"
				RouteId="6"
				Name="Err"
				Condition="elementcount(Errors) &gt; 0">
				<ModelAttributes>
					<ModelAttribute
						Name="UI_RouteWeight"
						Type="int"
						IsArray="false">
							<Value Val="5"/>
					</ModelAttribute>
				</ModelAttributes>
			</Route>
			<Route
				SourceStepId="0"
				DestinationStepId="3"
				RouteId="0"
				Name="Launch">
				<ModelAttributes>
					<ModelAttribute
						Name="UI_RouteWeight"
						Type="int"
						IsArray="false">
							<Value Val="95"/>
					</ModelAttribute>
				</ModelAttributes>
			</Route>
			<PostAssignments>
			<Assign LVal="ApproverCount" RVal="elementcount(Approvers)" />
			<Assign LVal="StartTime" RVal="F_StartTime" />
			<Assign LVal="EndDateMinuteOffset" RVal="days_between(ICN_WFDeadlineDate, StartTime) * 24 * 60" />
			<Assign LVal="EndDateSecondOffset" RVal="seconds_between(ICN_WFDeadlineDate, addminutes(StartTime, EndDateMinuteOffset))" />
			<Assign LVal="DeadlineInMins" RVal="if (ApproverCount=0 or ICN_WFDeadlineDate = NoDeadline, 0, (EndDateMinuteOffset + int(EndDateSecondOffset / 60)))" />
			<Assign LVal="F_WFDeadline" RVal="if (DeadlineInMins &gt; 0, DeadlineInMins, 0)" />
			<Assign LVal="Errors[1]" RVal="if (ApproverCount=0, &quot;E_NO_APPROVER&quot;, &quot;&quot;)" />
			<Assign LVal="Errors[2]" RVal="if (DeadlineInMins &lt; 0, &quot;E_NEG_DEADLINE&quot;, &quot;&quot;)" />
			<Assign LVal="Errors[3]" RVal="if (RequiredApprovalCount &lt; 0 or RequiredApprovalCount &gt; ApproverCount, &quot;E_REQ_APPROVAL_COUNT_OUT_OF_RANGE&quot;, &quot;&quot;)" />
			<Assign LVal="Errors[4]" RVal="if (RequiredApprovalPercentage &lt; 0 or RequiredApprovalPercentage &gt; 100, &quot;E_REQ_APPROVAL_PCT_OUT_OF_RANGE&quot;, &quot;&quot;)" />
			</PostAssignments>
			<ModelAttributes>
				<ModelAttribute
					Name="UI_StepType"
					Type="int"
					IsArray="false">
						<Value Val="1"/>
				</ModelAttribute>
			</ModelAttributes>
		</Step>
		<Step
			StepId="3"
			Name="Review"
			Description=""
			XCoordinate="506"
			YCoordinate="138"
			RequestedInterface="Navigator Step Pattern Processor"
			QueueName="Inbox"
			Deadline="if (DeadlineInMins&gt;0,  ICN_WFDeadlineDate, NoDeadline)"
			JoinType="or"
			SplitType="or"
			CanReassign="true"
			CanViewStatus="true"
			CanViewHistory="true"
			IgnoreInvalidUsers="false">
			<Participant Val="Approvers" />
			<Response Val="Approve" />
			<Response Val="Reject" />
			<Parameter
				Name="ICN_AllowReassign"
				ValueExpr="ICN_AllowReassign"
				Type="boolean"
				IsArray="false"
				Mode="in"/>
			<Parameter
				Name="ICN_Instructions"
				ValueExpr="ICN_Instructions"
				Type="string"
				IsArray="false"
				Mode="in"/>
			<Parameter
				Name="DocumentforReview"
				ValueExpr="DocumentforReview"
				Type="attachment"
				IsArray="false"
				Mode="in"/>
			<Parameter
				Name="References"
				ValueExpr="References"
				Type="attachment"
				IsArray="true"
				Mode="inout"/>
			<Route
				SourceStepId="3"
				DestinationStepId="7"
				RouteId="2"
				Name="Nay"
				Condition="(RequiredApprovalCount &gt; 0  and RequiredApprovalCount &gt; COUNT(Approve)) or (RequiredApprovalCount = 0 and RequiredApprovalPercentage &gt; ApprovalPercentage)">
				<ModelAttributes>
					<ModelAttribute
						Name="UI_RouteWeight"
						Type="int"
						IsArray="false">
							<Value Val="40"/>
					</ModelAttribute>
				</ModelAttributes>
			</Route>
			<Route
				SourceStepId="3"
				DestinationStepId="5"
				RouteId="1"
				Name="Aye"
				Condition="FinalReview = true">
				<ModelAttributes>
					<ModelAttribute
						Name="UI_RouteWeight"
						Type="int"
						IsArray="false">
							<Value Val="50"/>
					</ModelAttribute>
				</ModelAttributes>
			</Route>
			<Route
				SourceStepId="3"
				DestinationStepId="30"
				RouteId="4"
				Name="No Final Review">
				<ModelAttributes>
					<ModelAttribute
						Name="UI_RouteWeight"
						Type="int"
						IsArray="false">
							<Value Val="10"/>
					</ModelAttribute>
				</ModelAttributes>
			</Route>
			<PostAssignments>
			<Assign LVal="ApprovalPercentage" RVal="convert(F_Responses[1], float)/F_ResponseCount * 100.0" />
			</PostAssignments>
			<ModelAttributes>
				<ModelAttribute
					Name="UI_StepType"
					Type="int"
					IsArray="false">
						<Value Val="2"/>
				</ModelAttribute>
			</ModelAttributes>
		</Step>
		<Step
			StepId="5"
			Name="Approval Notification"
			XCoordinate="718"
			YCoordinate="136"
			RequestedInterface="Navigator Step Pattern Processor"
			QueueName="Inbox"
			JoinType="or"
			SplitType="or"
			CanReassign="false"
			CanViewStatus="true"
			CanViewHistory="true"
			IgnoreInvalidUsers="false">
			<Participant Val="F_Originator" />
			<Parameter
				Name="DocumentforReview"
				Description=""
				ValueExpr="DocumentforReview"
				Type="attachment"
				IsArray="false"
				Mode="in"/>
			<Parameter
				Name="References"
				Description=""
				ValueExpr="References"
				Type="attachment"
				IsArray="true"
				Mode="in"/>
			<ModelAttributes>
				<ModelAttribute
					Name="UI_StepType"
					Type="int"
					IsArray="false">
						<Value Val="2"/>
				</ModelAttribute>
			</ModelAttributes>
		</Step>
		<Step
			StepId="7"
			Name="Rework"
			XCoordinate="721"
			YCoordinate="231"
			RequestedInterface="Navigator Step Pattern Processor"
			QueueName="Inbox"
			JoinType="or"
			SplitType="or"
			CanReassign="false"
			CanViewStatus="true"
			CanViewHistory="true"
			IgnoreInvalidUsers="false">
			<Participant Val="F_Originator" />
			<Parameter
				Name="DocumentforReview"
				Description=""
				ValueExpr="DocumentforReview"
				Type="attachment"
				IsArray="false"
				Mode="in"/>
			<Parameter
				Name="References"
				Description=""
				ValueExpr="References"
				Type="attachment"
				IsArray="true"
				Mode="inout"/>
			<Route
				SourceStepId="7"
				DestinationStepId="3"
				RouteId="3"
				Name="Resubmit">
				<ModelAttributes>
					<ModelAttribute
						Name="UI_RouteWeight"
						Type="int"
						IsArray="false">
							<Value Val="100"/>
					</ModelAttribute>
				</ModelAttributes>
			</Route>
			<ModelAttributes>
				<ModelAttribute
					Name="UI_StepType"
					Type="int"
					IsArray="false">
						<Value Val="2"/>
				</ModelAttribute>
			</ModelAttributes>
		</Step>
		<Step
			StepId="30"
			Name="Final"
			XCoordinate="722"
			YCoordinate="34"
			RequestedInterface="Navigator Step Pattern Processor"
			JoinType="or"
			SplitType="or"
			CanReassign="true"
			CanViewStatus="true"
			CanViewHistory="true"
			IgnoreInvalidUsers="false">
			<Parameter
				Name="DocumentforReview"
				Description=""
				ValueExpr="DocumentforReview"
				Type="attachment"
				IsArray="false"
				Mode="in"/>
			<Parameter
				Name="References"
				Description=""
				ValueExpr="References"
				Type="attachment"
				IsArray="true"
				Mode="in"/>
			<ModelAttributes>
				<ModelAttribute
					Name="UI_StepType"
					Type="int"
					IsArray="false">
						<Value Val="2"/>
				</ModelAttribute>
			</ModelAttributes>
		</Step>
		<Step
			StepId="34"
			Name="Error"
			XCoordinate="505"
			YCoordinate="227"
			RequestedInterface="Navigator Step Pattern Processor"
			QueueName="Inbox"
			JoinType="or"
			SplitType="or"
			CanReassign="true"
			CanViewStatus="true"
			CanViewHistory="true"
			IgnoreInvalidUsers="false">
			<Participant Val="F_Originator" />
			<Parameter
				Name="Errors"
				ValueExpr="Errors"
				Type="string"
				IsArray="true"
				Mode="in"/>
			<Parameter
				Name="DocumentforReview"
				ValueExpr="DocumentforReview"
				Type="attachment"
				IsArray="false"
				Mode="in"/>
			<Parameter
				Name="References"
				ValueExpr="References"
				Type="attachment"
				IsArray="true"
				Mode="in"/>
			<ModelAttributes>
				<ModelAttribute
					Name="UI_StepType"
					Type="int"
					IsArray="false">
						<Value Val="2"/>
				</ModelAttribute>
			</ModelAttributes>
		</Step>
	</Map>
</WorkFlowDefinition>
